/* Simple interfaces to various protocols.
 *
 * (C) 2003 Anope Team
 * Contact us at info@anope.org
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Epona by Lara.
 * Based on the original code of Services by Andy Church. 
 * 
 * $Id: protocol.c 5 2004-03-29 01:29:50Z dane $ 
 *
 */

#include "services.h"

/* Makes an permanent ban from all the servers. Assumes that the matching clients are killed. */

void
s_akill(char *user, char *host, char *who, time_t when, time_t expires, char *reason)
{
	send_cmd(s_OperServ, "KLINE * %ld %s %s :%s",
		 (expires - (long int) time(NULL)), user, host, reason);
}

/*************************************************************************/

/* Removes a permanent ban from all the servers. */

void
s_rakill(char *user, char *host)
{
	send_cmd(s_OperServ, "UNKLINE * %s %s", user, host);
}

/*************************************************************************/

void
s_sqline(char *mask, char *reason)
{
	if(*mask == '#')
	{
		int i;
		Channel *c, *next;

		char *av[3];
		struct c_userlist *cu, *cunext;

		send_cmd(NULL, "RESV * %s :%s", mask, reason);

		for(i = 0; i < 1024; i++)
		{
			for(c = chanlist[i]; c; c = next)
			{
				next = c->next;

				if(!match_wild_nocase(mask, c->name))
					continue;

				for(cu = c->users; cu; cu = cunext)
				{
					cunext = cu->next;

					if(is_oper(cu->user))
						continue;

					av[0] = c->name;
					av[1] = cu->user->nick;
					av[2] = reason;
					send_cmd(s_OperServ, "KICK %s %s :Q-Lined: %s", av[0],
						 av[1], av[2]);
					do_kick(s_ChanServ, 3, av);
				}
			}
		}
	}
	else
	{
		send_cmd(NULL, "RESV * %s :%s", mask, reason);
	}
}

/*************************************************************************/

void
s_unsqline(char *mask)
{
	send_cmd(NULL, "UNRESV * %s", mask);
}

/*************************************************************************/
